--    Program: 		CAPPOIMP_RFQ_VENDOR.sql
--    Description:  Import PO RFQ VENDORS information 
--    Revision:     1st     
--    Parameter: 	
--    Created By:   Kenny Leung
--    Date:         23-Jan-2006

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
   l_err_msg_tmp			varchar2(2000);
                    		                 		
   cursor cur_rfq_vendors is
      select * from CRST_PO_RFQ_VENDORS;

begin
   l_processed_count := 0;
   l_rejected_count  := 0;
   l_err_msg := '';
   
   for cur in cur_rfq_vendors loop   	
     l_err_msg_tmp := '';
     
     begin
       -- import data
       insert into PO_RFQ_VENDORS
       (
            PO_HEADER_ID            ,
            SEQUENCE_NUM            ,
            LAST_UPDATE_DATE        ,
            LAST_UPDATED_BY         ,
            LAST_UPDATE_LOGIN       ,
            CREATION_DATE           ,
            CREATED_BY              ,
            VENDOR_ID               ,
            VENDOR_SITE_ID          ,
            VENDOR_CONTACT_ID       ,
            PRINT_FLAG              ,
            PRINT_COUNT             ,
            PRINTED_DATE            ,
            ATTRIBUTE_CATEGORY      ,
            ATTRIBUTE1              ,
            ATTRIBUTE2              ,
            ATTRIBUTE3              ,
            ATTRIBUTE4              ,
            ATTRIBUTE5              ,
            ATTRIBUTE6              ,
            ATTRIBUTE7              ,
            ATTRIBUTE8              ,
            ATTRIBUTE9              ,
            ATTRIBUTE10             ,
            ATTRIBUTE11             ,
            ATTRIBUTE12             ,
            ATTRIBUTE13             ,
            ATTRIBUTE14             ,
            ATTRIBUTE15             ,
            REQUEST_ID              ,
            PROGRAM_APPLICATION_ID  ,
            PROGRAM_ID              ,
            PROGRAM_UPDATE_DATE     
       )
       values
       (
            CAPPOIMP_MAPPING.GetPOHeaderIDMapping(cur.PO_HEADER_ID),
            cur.SEQUENCE_NUM            ,
            cur.LAST_UPDATE_DATE        ,
            CUR.LAST_UPDATED_BY,
            cur.LAST_UPDATE_LOGIN       ,
            cur.CREATION_DATE           ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.CREATED_BY),
            CAPPOIMP_MAPPING.GetVendorIDMapping(cur.VENDOR_ID),
            CAPPOIMP_MAPPING.GetVendorSiteIDMapping(cur.VENDOR_SITE_ID),
            CAPPOIMP_MAPPING.GetVendorContactIDMapping(cur.VENDOR_CONTACT_ID),
            cur.PRINT_FLAG              ,
            cur.PRINT_COUNT             ,
            cur.PRINTED_DATE            ,
            cur.ATTRIBUTE_CATEGORY      ,
            cur.ATTRIBUTE1              ,
            cur.ATTRIBUTE2              ,
            cur.ATTRIBUTE3              ,
            cur.ATTRIBUTE4              ,
            cur.ATTRIBUTE5              ,
            cur.ATTRIBUTE6              ,
            cur.ATTRIBUTE7              ,
            cur.ATTRIBUTE8              ,
            cur.ATTRIBUTE9              ,
            cur.ATTRIBUTE10             ,
            cur.ATTRIBUTE11             ,
            cur.ATTRIBUTE12             ,
            cur.ATTRIBUTE13             ,
            cur.ATTRIBUTE14             ,
            cur.ATTRIBUTE15             ,
            cur.REQUEST_ID              ,
            cur.PROGRAM_APPLICATION_ID  ,
            cur.PROGRAM_ID              ,
            cur.PROGRAM_UPDATE_DATE     
       );  
     exception
       when others then
     	 l_err_msg_tmp := sqlerrm;
     end;	  	    
     
     if l_err_msg_tmp IS NULL then
       l_processed_count := l_processed_count + 1;  
     else
       l_rejected_count := l_rejected_count + 1;
       l_err_msg := l_err_msg_tmp; 
     end if;
   end loop;

   if l_rejected_count = 0 then
   	 commit;
   else
     rollback;
   end if;
   
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPPOIMP_RFQ_VENDOR', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/


--exit
